Stop ssh and mdadm in bailout
[grml-debootstrap.git] / grml-debootstrap
index d50ff6f..674a3ad 100644 (file)
@@ -4,21 +4,25 @@
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Fre Nov 10 00:50:55 CET 2006 [mika]
+# Latest change: Mon Apr 09 15:34:02 CEST 2007 [mika]
 ################################################################################
-# http://www.debian.org/releases/stable/i386/apcs04.html.en
+# http://www.debian.org/releases/stable/i386/index.html.en
 
 set -e # exit on any error
 
 . /etc/grml/lsb-functions
 . /etc/grml/script-functions
 
-VERSION='0.2'
+# inside the chroot system the locales might not be available, so use minimum:
+export LANG=C
+export LC_ALL=C
+
+VERSION='0.6'
 
 case $* in
    -h*|--h*)
      einfo "$0 - wrapper around debootstrap for installing plain Debian via grml"
-     einfo "Configure via /etc/debootstrap/config and invoke $0 afterwards."
+     einfo "Adjust /etc/debootstrap/config and invoke $0 afterwards."
      eend 0
      exit 0
    ;;
@@ -41,16 +45,23 @@ else
    exit 1
 fi
 
+if [ -z "$STAGES" ] ; then
+   STAGES='/etc/debootstrap/stages'
+   [ -d "$STAGES" ] || mkdir -p "$STAGES"
+fi
+
 # make sure at least $TARGET is set [the partition for the new system]
 if [ -z "$TARGET" ] ; then
    eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
    exit 1
 fi
 
-function bailout(){
+bailout(){
   # make sure $TARGET is not mounted when exiting grml-debootstrap
   if [ -n "$TARGET" ] ; then
      if grep -q $TARGET /proc/mounts ; then
+        [ -x "$TARGET"/etc/init.d/ssh   ] && "$TARGET"/etc/init.d/ssh stop
+        [ -x "$TARGET"/etc/init.d/mdadm ] && "$TARGET"/etc/init.d/mdadm stop
         echo "Unmounting $TARGET"
         umount "$TARGET"
      fi
@@ -59,17 +70,57 @@ function bailout(){
   exit "$EXIT"
 }
 
+stage() {
+  # error handling
+  if [ -z "$1" ] ; then
+     eerror 'Error: stage() requires at least one argument.'
+     eend 1
+     return 1
+  fi
+  if [ -z "$STAGES" ] ; then
+     eerror 'Error: $STAGES not set.'
+     eend 1
+     return 1
+  fi
+  # main function
+  if [ -f "$STAGES/$1" ] ; then
+     if grep -q done "$STAGES/$1" ; then
+        ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
+     fi
+  else
+     echo "$2" > "$STAGES/$1"
+  fi
+}
+
 trap bailout 1 2 3 15
 
+PARTITION=''
+DIRECTORY=''
+
+case $TARGET in
+  /dev/*)
+    PARTITION=1
+    ;;
+  *)
+    # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
+    DIRECTORY=1
+    MNTPOINT="$TARGET"
+    MKFS=''
+    TUNE2FS=''
+    FSCK=''
+    GRUB=''
+    GROOT=''
+    ;;
+esac
+
 # user should recheck his configuration
 einfo "$0 - Please recheck configuration before execution:"
 echo "
-   Target partition: $TARGET
-   Mount-point:      $MNTPOINT
-   Install grub to:  $GROOT / $GRUB  [if empty grub will not be installed]
-
-   Important! Continuing will delete all data from ${TARGET}!
-"
+   Target:           $TARGET"
+   case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
+   [ -n "$GRUB" ] && echo "   Install grub to:  $GROOT / $GRUB"
+   case "$MNTPOINT" in "$TARGET") ;; *) echo "  Important! Continuing will delete all data from ${TARGET}!" ;; esac
+   echo
 einfon "Is this ok for you? [y/N] "
 
 read a
@@ -79,37 +130,55 @@ if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
 fi
 
 if [ -n "$MKFS" ] ; then
+   stage mkfs
    einfo "Running $MKFS on $TARGET"
    $MKFS $TARGET
    eend $?
+   stage mkfs done
 fi
 
+
 if [ -n "$TUNE2FS" ] ; then
+   stage tune2fs
    einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
    $TUNE2FS $TARGET
    eend $?
+   stage tune2fs done
 fi
 
-# now mount the new partition
-if grep -q $TARGET /proc/mounts ; then
-   eerror "$TARGET already mounted, exiting."
+
+# now mount the new partition or if it's a directory do nothing at all
+if [ -n "$DIRECTORY" ] ; then
+   einfo "Running grml-debootstrap on a directory, nothing to mount."
 else
-  [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
-  einfo "Mounting $TARGET to $MNTPOINT"
-  [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
-  mount -o rw,suid,dev $TARGET $MNTPOINT
-  eend $?
+   if grep -q $TARGET /proc/mounts ; then
+      eerror "$TARGET already mounted, exiting."
+   else
+     [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
+     [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
+     einfo "Mounting $TARGET to $MNTPOINT"
+     mount -o rw,suid,dev $TARGET $MNTPOINT
+     eend $?
+   fi
 fi
 
 # get main packages from a debian-mirror
 if [ -n "$ARCH" ] ; then
    ARCHCMD="--arch $ARCH"
    ARCHINFO=" (${ARCH})"
+else
+   ARCH="$(dpkg --print-architecture)"
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
 fi
+
+stage debootstrap
 einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using mirror $MIRROR"
 $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR
+stage debootstrap done
 eend $?
 
+stage preparechroot
 einfo "Preparing chroot system"
   cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
@@ -132,10 +201,13 @@ einfo "Preparing chroot system"
   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
 eend 0
+stage preparechroot done
 
+stage chrootscript
 einfo "Executing chroot-script now"
-chroot $MNTPOINT /bin/chroot-script
+chroot "$MNTPOINT" /bin/chroot-script
 eend $?
+stage chrootscript done
 
 # einfo "Removing chroot-script"
 # rm -f  $MNTPOINT/bin/chroot-script
@@ -145,22 +217,31 @@ eend $?
 if [ -z "$GRUB" -o -z "$GROOT" ] ; then
    echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
 else
+   stage grubinstall
    einfo "Installing grub on ${GRUB}:"
    grub-install --root-directory="$MNTPOINT" "(${GRUB})"
    eend $?
+   stage grubinstall done
 fi
 
-einfo "Unmount $MNTPOINT"
-umount $MNTPOINT
-eend $?
+if [ -n "$PARTITION" ] ; then
+   einfo "Unmount $MNTPOINT"
+   umount $MNTPOINT
+   eend $?
+fi
 
 if [ "$FSCK" = 'yes' ] ; then
+   stage fscktool
    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
    $FSCKTOOL $TARGET
    eend $?
+   stage fscktool done
 fi
 
+# finally remove stages on main system so grml-deboostrap can be reexecuted
+  rm -rf "$STAGES"
+
 einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
 
 ## END OF FILE #################################################################